
//   create a shared (dynamic) library
// gcc -O3 -c LDL2.c -o LDL2.o
// gcc -shared -o libLDL2.so LDL2.o

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

void LDL_factor(int N, double *L, double *d) {
    int  i, j, k;
 	
    for (k=0; k<N; k++) {
        d[k] = L[k*N + k];
        L[k*N + k] = 1.0;
        for (i=k+1; i<N; i++) {
            L[i*N + k] /= d[k];
            for (j=k+1; j<=i; j++)
                L[i*N + j] -= d[k]*L[i*N + k]*L[j*N + k];
        }
    }		
}

// ---------------------------------------------------------------

void LDL_solve(int N, double *L, double *d, double *b, double *x) {
	int i, j, k;
    
	double *z;
    z = malloc(N*sizeof(double));
    for (k = 0; k<N; k++) z[k] = b[k];
    
    for (j=0; j<N; j++)  {
        for (i=0; i<j; i++)
            z[j] -= L[j*N + i]*z[i];
        x[j] = z[j]/d[j];    
    }
    
    for (j=N-1; j>=0; j--)
        for (i=j+1; i<N; i++)
            x[j] -= L[i*N + j]*x[i];
    
    free(z);
 }
