from ctypes import *
from scipy import zeros, float64, tril, reshape

ct = cdll.LoadLibrary('libLDL2.so')
ldlFactor = getattr(ct,'LDL_factor')
ldlSolve = getattr(ct,'LDL_solve')

ldlFactor.restype = None
ldlSolve.restype = None


def LDL_factor(A):
    N = len(A[0])
    L = tril(A)
    L = reshape(L,(N**2,1))
    d = zeros(N)
    ldlFactor( c_int(N), c_void_p(L.ctypes.data), c_void_p(d.ctypes.data) )
    
    return reshape(L,(N,N)), d




def LDL_solve(L,d,b):
    N = len(b)
    x = zeros(N,dtype=float64)
    L = reshape(L,(N**2,1))
    ldlSolve( c_int(N), c_void_p(L.ctypes.data), c_void_p(d.ctypes.data), c_void_p(b.ctypes.data), c_void_p(x.ctypes.data) )
    
    return x