function [x, delta, it] = RLL(A,b,mu,maxIt,tol)
    switch nargin
        case 2
            mu = 5e-15;
            maxIt = 3;
            tol = 1e-4;
        case 3
            maxIt = 3;
            tol = 1e-4;
        case 4
            tol = 1e-4;
    end

    N = length(b);
    A(1:N+1:end) = A(1:N+1:end) + mu;  % C = A + mu*eye(N);
    L = chol(A,'lower');
    z = L\b;
    y = L'\z;
    sizeY = norm(y,2);
    x = y;

    relativeChange = 0; relativeChangeOld = 1e15;
    it = 0; delta = zeros(maxIt,1);
    while it<maxIt
        z = mu*(L\y);
        y = L'\z;
        correctionSize = norm(y,2);
        relativeChange = correctionSize/sizeY;
        if relativeChange>relativeChangeOld || relativeChange<tol
            break;
        end
        it = it + 1;
        relativeChangeOld = relativeChange;
        delta(it) = relativeChange;
        x = x + y;

    end
end