function x = RLLDM(A,B,mu)
    if nargin<3
        mu = 5e-15;
    end
    s = size(A);
    N = s(1);
    D = zeros(N,N);
    A(1:N+1:end) = A(1:N+1:end) + mu;  % C = A + mu*eye(N);
    L = chol(A,'lower');
    
    for k=1:N
        z = L\B(:,k);
        x0 = L'\z;
        z = mu*(L\x0);
        x1 = L'\z;
        D(:,k) = x0 + x1;
    end
end